#
# Name: hp_qla2x00.spec
# Copyright: (c)2004 Hewlett-Packard Company
#
# Description: spec file for hp_qla2x00 RPM

Name: hp_qla2x00 
Version: 7.01.01
Release: 9
Summary: HP QLA HBA Driver 
Source: hp_qla2x00.tar.gz
Vendor: Hewlett-Packard
Copyright: proprietary
Group: System/Kernel 
BuildRoot: %{_builddir}/hp_qla2x00

%undefine __check_files

%description
Loads the HP supported QLogic HBA driver.  

%prep

# use this section ot untar the source file

rm -fr $RPM_BUILD_DIR/hp_qla2x00
gunzip $RPM_SOURCE_DIR/hp_qla2x00.tar.gz
tar xvf $RPM_SOURCE_DIR/hp_qla2x00.tar

%build

# execute condition kernel script

$RPM_BUILD_ROOT/condition_kernel

# determine what OSVER flag should be

if [ -d /usr/src/linux-include ]
then
 OSVER=linux-include/`uname -r | awk 'BEGIN {FS="-"} {if ($4 == "") print $3; else print $3"-"$4}'`
elif [ -d /usr/src/linux-2.4 ]
then
 OSVER=linux-2.4
else
 OSVER=linux
fi

# determine SMP flag

if [ "`cat /proc/version | grep SMP`" = "" ]
then
 SMP=0
else
 SMP=1
fi

# build driver

cd $RPM_BUILD_ROOT
make clean
make OSVER=$OSVER SMP=$SMP all

%install

OPTDIR=opt/hp/hp_qla2x00
LIBDIR=usr/lib

# copy opt directory files

mkdir -p $RPM_BUILD_ROOT/$OPTDIR
cp $RPM_BUILD_ROOT/qla2200.o $RPM_BUILD_ROOT/$OPTDIR/qla2200.o
cp $RPM_BUILD_ROOT/qla2300.o $RPM_BUILD_ROOT/$OPTDIR/qla2300.o
cp $RPM_BUILD_ROOT/qla2300_conf.o $RPM_BUILD_ROOT/$OPTDIR/qla2300_conf.o
cp $RPM_BUILD_ROOT/qla_opts $RPM_BUILD_ROOT/$OPTDIR/qla_opts
cp $RPM_BUILD_ROOT/set_parm $RPM_BUILD_ROOT/$OPTDIR/set_parm
cp $RPM_BUILD_ROOT/edit_conf $RPM_BUILD_ROOT/$OPTDIR/edit_conf
cp $RPM_BUILD_ROOT/make_initrd $RPM_BUILD_ROOT/$OPTDIR/make_initrd
cp $RPM_BUILD_ROOT/README $RPM_BUILD_ROOT/$OPTDIR/README
cp $RPM_BUILD_ROOT/readme.libqlsdm $RPM_BUILD_ROOT/$OPTDIR/readme.libqlsdm
cp $RPM_BUILD_ROOT/set_parm2 $RPM_BUILD_ROOT/$OPTDIR/set_parm2

# copy /etc files

mkdir -p $RPM_BUILD_ROOT/etc
touch $RPM_BUILD_ROOT/etc/.hp_pkinstall

# copy qlsdm library based on architecture

mkdir -p $RPM_BUILD_ROOT/$LIBDIR
if [ "`uname -m`" = "i386" ] || [ "`uname -m`" = "i486" ] || [ "`uname -m`" = "i586" ] || [ "`uname -m`" = "i686" ] || [ "`uname -m`" = "x86_64" ]
then
 cp $RPM_BUILD_ROOT/libqlsdm-ia32.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
elif [ "`uname -m`" = "ia64" ]
then
 cp $RPM_BUILD_ROOT/libqlsdm-ia64.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
fi

%files

%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2200.o
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2300.o
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2300_conf.o
%attr (700,root,root)	/opt/hp/hp_qla2x00/qla_opts
%attr (744,root,root)	/opt/hp/hp_qla2x00/edit_conf
%attr (744,root,root)	/opt/hp/hp_qla2x00/make_initrd
%attr (744,root,root)	/opt/hp/hp_qla2x00/set_parm
%attr (744,root,root)	/opt/hp/hp_qla2x00/set_parm2
%attr (444,root,root)	/opt/hp/hp_qla2x00/README
%attr (444,root,root)	/opt/hp/hp_qla2x00/readme.libqlsdm
%attr (444,root,root)	/etc/.hp_pkinstall
%attr (644,root,root)	/usr/lib/libqlsdm.so


%clean

rm -fr $RPM_BUILD_DIR/hp_qla2x00
gzip $RPM_SOURCE_DIR/hp_qla2x00.tar

%changelog
* Wed Sep 29 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added EVA failover patch

* Thu Sep 23 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added more fixes for parsing RHAS 2.1 test or hotfix
  kernels

* Tue Sep 08 2004 Chad Dupuis <chad.dupuis@hp.com>

- Parse hotfix or TEST kernels in Red Hat AS 2.1
  correctly
- If a machine is a x86_64 architecture but is
  running an Intel 32e processor, change ARCH to
  ia32e

* Fri Aug 27 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added fix to condition_kernel that parses RHEL3
  kernel name with Secure Path fix correctly

* Fri Aug 20 2004 Chad Dupuis <chad.dupuis@hp.com>

- Removed fixes for RHEL 3, U3 naming problem
- Exit from condition_kernel if .config file doesn't exist

* Thu Aug 19 2004 Chad Dupuis <chad.dupuis@hp.com>

- Move qla2200_conf.o and qla2300_conf.o files in the ...addon/qla2200
  directory on RHEL 3 if they exist

* Tue Aug 17 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added new make_initrd
- Added fix to condition_kernel to parse RHEL 3, U3
  kernel names correctly

* Thu Aug 12 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added code to determine if currently loaded driver
  is in failover or nonfailover mode
- Added 7.01.01 driver sources

* Fri Jul 23 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added 7.00.04b5 driver sources

* Mon Jul 19 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added 7.00.04b4 driver source

* Thu Jun 21 2004 Chad Dupuis <chad.dupuis@hp.com>

- Fixed make_initrd to only make a new initrd for
  the running kernel on SUSE distributions

* Thu Jun 17 2004 Chad Dupuis <chad.dupuis@hp.com>

- Updated condition_kernel to work correctly on AMD Opeteron
  servers with the OS running in a pure 32-bit mode

* Mon Jun 14 2004 Chad Dupuis <chad.dupuis@hp.com>

- Added support for x86_64 architecture
- Added preinstall check for 2.4 kernel

%pre

# make sure we are installing on a 2.4 kernel

KERNVER=`uname -r | cut -c 1-3`

if [ "$KERNVER" != "2.4" ]
then
 echo ""
 echo "This machine is not running a 2.4 kernel!"
 echo ""
 exit 1
fi

%post

SRCDIR=/opt/hp/hp_qla2x00

# create hp_qla2x00.conf if needed

ls /etc/hp_qla2x00.conf 1>/dev/null 2>/dev/null

if [ $? -ne 0 ]
then
 # determine if a driver already loaded in memory is in failover mode
 # or single path mode.  If no driver is loade default to single path

 if test -d /proc/scsi/qla2300
 then
        FOMODE=`more /proc/scsi/qla2300/* | grep "Driver version" | grep fo`

        # use set_parm2 to write out the correct settings

        if [ "$FOMODE" = "" ]
        then
                echo "Loaded driver is in nonfailover mode"
                $SRCDIR/set_parm2 -s
        else
                echo "Loaded driver is in failover mode"
                $SRCDIR/set_parm2 -x
        fi
 else
        # no driver loaded, so default to failover mode

        echo "No driver loaded, using failover mode"
        $SRCDIR/set_parm2 -x
 fi
else
 echo "/etc/hp_qla2x00.conf already exists.  Using parameters in the current file."
fi

# Modify /etc/hba.conf

if [ -f "/etc/hba.conf" ]
then
 # file exists, see if we need to make the edit

 if [ `grep -c qla2x00 /etc/hba.conf` -eq 0 ]
 then
        echo "Modifying /etc/hba.conf"
        echo "qla2x00   /usr/lib/libqlsdm.so" >> /etc/hba.conf
 fi
else
 # file does not exist, create it

 echo "Modifying /etc/hba.conf"
 echo "qla2x00  /usr/lib/libqlsdm.so" >> /etc/hba.conf
fi

# determine correct module directory

if [ -d /lib/modules/`uname -r`/kernel/drivers/addon/qla2xxx ]
then
 MODDIR=/lib/modules/`uname -r`/kernel/drivers/addon/qla2xxx
elif [ -d /lib/modules/`uname -r`/kernel/drivers/addon/qla2200 ]
then
 MODDIR=/lib/modules/`uname -r`/kernel/drivers/addon/qla2200
else
 MODDIR=/lib/modules/`uname -r`/kernel/drivers/scsi
fi
SCSIDIR=/lib/modules/`uname -r`/kernel/drivers/scsi

# save qla2300, qla2300_conf.o

echo "Saving old modules"

if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
then
 if [ -a $MODDIR/qla2200.o ]
 then
 	mv $MODDIR/qla2200.o $MODDIR/qla2200.old
 fi

 if test -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.o
 then
        mv -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.o /lib/modules/${KERNELVERSION}/kernel/
drivers/addon/qla2200/qla2200_conf.orig
 fi
fi

if [ -a $MODDIR/qla2300.o ]
then
 mv $MODDIR/qla2300.o $MODDIR/qla2300.old
fi

if [ -a $SCSIDIR/qla2300_conf.o ]
then
 mv $SCSIDIR/qla2300_conf.o $MODDIR/qla2300_conf.old
fi

if test -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.o
then
 mv -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.o /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.orig
fi

# copy qla2300, qla2300_conf.o

echo "Copying new modules from $SRCDIR"

if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
then
 cp ${SRCDIR}/qla2200.o ${MODDIR}/qla2200.o
fi

cp ${SRCDIR}/qla2300.o ${MODDIR}/qla2300.o
cp ${SRCDIR}/qla2300_conf.o ${SCSIDIR}/qla2300_conf.o

# run depmod

echo "Running depmod -a"
depmod -a

# run qla_opts if need be

if [ -a /etc/qla2300.conf ]
then
 echo "Updating qla2300_conf with configuration data from /etc/qla2300.conf"
 ${SRCDIR}/qla_opts -w qla2300_conf
fi

# edit configuration files

$SRCDIR/edit_conf

# make new initrd

$SRCDIR/make_initrd

echo ""
echo "Utility files are located in $SRCDIR"

%preun

%postun

ls /etc/.hp_pkinstall 1>/dev/null 2>/dev/null

if [ $? -ne 0 ]
then
 SRCDIR="/opt/hp/hp_qla2x00"

 # remove /etc/hp_qla2x00.conf

 echo "Removing /etc/hp_qla2x00.conf"
 rm -f /etc/hp_qla2x00.conf

 # remove reference from /etc/hba.conf to qla2x00

 echo "Removing reference to qla2x00 from /etc/hba.conf"
 cat /etc/hba.conf | grep -v qla2x00 > /tmp/hba.conf
 mv /etc/hba.conf /etc/hba.conf.old
 mv /tmp/hba.conf /etc/hba.conf
 chmod 644 /etc/hba.conf
 chown root:root /etc/hba.conf

 # set module directories

 if [ -d /lib/modules/`uname -r`/kernel/drivers/addon/qla2xxx ]
 then
 	MODDIR=/lib/modules/`uname -r`/kernel/drivers/addon/qla2xxx
 elif [ -d /lib/modules/`uname -r`/kernel/drivers/addon/qla2200 ]
 then
 	MODDIR=/lib/modules/`uname -r`/kernel/drivers/addon/qla2200
 else
 	MODDIR=/lib/modules/`uname -r`/kernel/drivers/scsi
 fi
 SCSIDIR=/lib/modules/`uname -r`/kernel/drivers/scsi

 # remove current modules

 echo "Removing (qla2200.o) qla2300.o and qla2300_conf.o"

 if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
 then
 	rm -f ${MODDIR}/qla2200.o
 fi

 rm -f ${MODDIR}/qla2300.o
 rm -f ${MODDIR}/qla2300_conf.o

 # restore old modules

 echo "Restoring old (qla2200.o) qla2300.o and qla2300_conf.o modules"

 if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
 then
 	if [ -a ${MODDIR}/qla2200.old ]
 	then
 		mv ${MODDIR}/qla2200.old ${MODDIR}/qla2200.o
 	fi
 
 	if test -f /lib/modules/`uname -r`/kernel/drivers/addon/qla2200/qla2200_conf.orig
        then
                echo "Restoring qla2200_conf.o in /lib/modules/`uname -r`/kernel/drivers/addon/qla2200"
                mv -f /lib/modules/`uname -r`/kernel/drivers/addon/qla2200/qla2200_conf.orig /lib/modules/`uname -r`/kernel/d
rivers/addon/qla2200/qla2200_conf.o
        fi
 fi

 if [ -a ${MODDIR}/qla2300.old ]
 then
 	mv ${MODDIR}/qla2300.old ${MODDIR}/qla2300.o
 fi

 if [ -a ${SCSIDIR}/qla2300_conf.old ]
 then
  mv ${SCSIDIR}/qla2300_conf.old ${SCSIDIR}/qla2300_conf.o 
 fi

 if test -f /lib/modules/`uname -r`/kernel/drivers/addon/qla2200/qla2300_conf.orig
 then
        echo "Restoring qla2300_conf.o in /lib/modules/`uname -r`/kernel/drivers/addon/qla2200"
        mv -f /lib/modules/`uname -r`/kernel/drivers/addon/qla2200/qla2300_conf.orig /lib/modules/`uname -r`/kernel/drivers/addon/qla2200/qla2300_conf.o
 fi

 # run depmod

 echo "Running depmod -a"
 depmod -a

 # remove entries from /etc/modules.conf

 echo "Removing entries for qla2200 and qla2300 from /etc/modules.conf"
 cat /etc/modules.conf | grep -v "alias scsi_hostadapter.* qla2200_conf"| grep -v "alias scsi_hostadapter.* qla2300_conf" | grep -v "post-remove qla2200 rmmod qla2200_conf" | grep -v "post-remove qla2300 rmmod qla2300_conf" | grep -v "options qla2200" | grep -v "options qla2300" | grep -v "alias scsi_hostadapter.* sg"  > /tmp/modules.tmp
 mv -f /etc/modules.conf /etc/modules.conf.old
 mv -f /tmp/modules.tmp /etc/modules.conf

 # remove entries from /etc/sysconfig/kernel if needed

 if [ -a /etc/sysconfig/kernel ]
 then
 	echo "Removing entries for qla2300_conf and sg from /etc/sysconfig/kernel"
 	cat /etc/sysconfig/kernel | sed 's/qla2300_conf//g' | sed 's/sg//g' > /etc/sysconfig/kernel.tmp
 	mv -f /etc/sysconfig/kernel /etc/sysconfig/kernel.old
 	mv -f /etc/sysconfig/kernel.tmp /etc/sysconfig/kernel
 	chmod 644 /etc/sysconfig/kernel
 	chown root:root /etc/sysconfig/kernel
 fi

 # remove /opt/hp/src/hp_qla2x00src

 echo "Removing $SRCDIR"
 cd $SRCDIR
 
 if [ $? -eq 0 ]
 then
	rm -f *
 	cd ../
 	rmdir $SRCDIR
 fi

 echo ""
 echo "Your initrd has not been updated.  You will have to do that manually."
else
 # if this is an upgrade, don't remove anything

 echo -n "" # no-op
fi

exit 0

